﻿using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using Telerik.Windows.Persistence.Services;

namespace RadGridView_SL4_AR_11
{
	public class FilterDescriptorCustomPropertyProvider : ICustomPropertyProvider
	{
		public CustomPropertyInfo[] GetCustomProperties()
		{
			return new CustomPropertyInfo[]
            {
                new CustomPropertyInfo("FilterDescriptors", typeof(CompositeFilterDescriptorCollection)),
            };
		}

		public void InitializeObject(object context)
		{
			RadDataFilter filter = context as RadDataFilter;
			filter.FilterDescriptors.Clear();
		}

		public object InitializeValue(CustomPropertyInfo customPropertyInfo, object context)
		{
			return null;
		}

		public object ProvideValue(CustomPropertyInfo customPropertyInfo, object context)
		{
			RadDataFilter filter = context as RadDataFilter;
			if (customPropertyInfo.Name == "FilterDescriptors")
			{
				return filter.FilterDescriptors;
			}
			return null;
		}

		public void RestoreValue(CustomPropertyInfo customPropertyInfo, object context, object value)
		{
			RadDataFilter filter = context as RadDataFilter;
			if (customPropertyInfo.Name == "FilterDescriptors")
			{
				CompositeFilterDescriptorCollection filters = value as CompositeFilterDescriptorCollection;
				if (filter != null)
				{
					foreach (var item in filters)
					{
						filter.FilterDescriptors.Add(item);
					}
				}
			}
		}
	}
}
